//(1)VALEDCu(zz https://github.com/adafruit/Adafruit_NeoPixel)
#include <Adafruit_NeoPixel.h>
//(2)Arduino HID Project 2.4.4(zz https://github.com/NicoHood/HID#arduino-hid-project-244)
#include <HID-Project.h>
#include <HID-Settings.h>

//L[R[hw
#define C_SHIFT		0x1000		// SHIFT+ wR[h
#define	C_MEDIA		0x2000		// fBAL[(RV[}[@\pj

#define	KC_CALC	(C_MEDIA | 0x1 )	// dL[

#define KC_SHIFT	0xe1		//  SHIFT
#define	KC_DOT		0x63		// Keypad [.]
#define	KC_P0		0x62		// Keypad [0]
#define	KC_P9		0x61		// Keypad [9]
#define	KC_P8		0x60		// Keypad [8]
#define	KC_P7		0x5f		// Keypad [7]
#define	KC_P6		0x5e		// Keypad [6]
#define	KC_P5		0x5d		// Keypad [5]
#define	KC_P4		0x5c		// Keypad [4]
#define	KC_P3		0x5b		// Keypad [3]
#define	KC_P2		0x5a		// Keypad [2]
#define	KC_P1		0x59		// Keypad [1]

#define	KC_ENTER	0x58		// Keypad [Enter]
#define	KC_PLUS		0x57		// Keypad [+]
#define	KC_MINS		0x56		// Keypad [-]
#define	KC_ASTR		0x55		// Keypad [*]
#define	KC_DIV		0x54		// Keypad [/]
#define KC_NUML		0x53		// [NUM LOCK]

#define	KC_COMMA	0x36		// Keyboard [,]
#define	KC_EQL	(C_SHIFT | 0x2d)	// Keyboard [=] ([SHIFT]+[-])
#define	KC_BS		0x2a		// [BACK SPACE]
#define	KC_ESC		0x29		// [ESC]
#define	KC_9	(C_SHIFT | 0x26)	// Keyboard [)] ([SHIFT]+[9])
#define	KC_8	(C_SHIFT | 0x25)	// Keyboard [(] ([SHIFT]+[8])

//KEY SCANp I/O`
#define   ROW_NUM 7
#define   COL_NUM 4
const int rowPins[ROW_NUM] = {  2,  3,  4,  5,  6,  7,  8 };  // OUTPUTw
const int colPins[COL_NUM] = {  9, 10, 16, 14 };        // INPUT_PULLUPw

//KEY MAP`(JISR[h)
const unsigned int keyMap[ROW_NUM][COL_NUM] = {
  { KC_NUML	, KC_NUML	, KC_NUML	, KC_NUML	}, //MODEL[̓_~[
  { KC_NUML	, KC_CALC	, KC_ESC	, KC_BS		}, //NML CALC ESC BS
  { KC_8	, KC_9		, KC_MINS	, KC_DIV	}, // (   )   -   /
  { KC_P7	, KC_P8		, KC_P9		, KC_ASTR	}, // 7   8   9   *
  { KC_P4	, KC_P5		, KC_P6		, KC_PLUS	}, // 4   5   6   +
  { KC_P1	, KC_P2		, KC_P3		, KC_EQL	}, // 1   2   3   =
  { KC_P0	, KC_COMMA	, KC_DOT	, KC_ENTER	}  // 0   ,   .   RET
};

//LEDp I/O`
#define NUMPIXELS     1     // VALED
#define NUM_LOCK_LED    21      // NumLock/샂[hLED|[gԍ

//VALED`
//  D2812   = NEO_RGB
//  WS2812B = NEO_GRB
Adafruit_NeoPixel pixels = Adafruit_NeoPixel(NUMPIXELS, NUM_LOCK_LED, NEO_GRB + NEO_KHZ800);  //NumLock LEDPin

//NumLockELED
int R[3];            // LEDF Red  (0-255)
int G[3];            // LEDF Green(0-255)
int B[3];            // LEDF Blue (0-255)

//KEYԐpz`
//KEYԂOƍŐVԂŔrāAωꍇɃL[R[h𑗐M
bool cur_key_sts[ROW_NUM][COL_NUM]; //ŐVKEY
bool old_key_sts[ROW_NUM][COL_NUM]; //OKEY

void setup()
{
  // put your setup code here, to run once:
  //L[XLsPin
  for (int i = 0; i < ROW_NUM; i++)
  {
    pinMode(rowPins[i], OUTPUT);
  }
  //L[XLPin
  for (int i = 0; i < COL_NUM; i++)
  {
    pinMode(colPins[i], INPUT_PULLUP);
  }
  //L[Ԃ
  for (int row = 0; row < ROW_NUM; row++)
  {
    //L[Ԃu[XvƂ
    for (int c = 0; c < COL_NUM; c++)
    {
      cur_key_sts[row][c] = HIGH;
      old_key_sts[row][c] = HIGH;
    }
    //L[XLsPinHIGH(inactive)ɂ
    digitalWrite(rowPins[row], HIGH);
  }
  //LED\(e샂[hʂRGBŐFw肷)
  //F1=
  R[0]=0;
  G[0]=10;
  B[0]=0;

  //VALEDCu
  pixels.begin();

  //HIDfoCX(zXgLEDԎ擾p)
  BootKeyboard.begin();

  //RV[}[@\
  Consumer.begin();
}

void loop()
{
  // put your main code here, to run repeatedly:
  static int mode = 0;//FύXp

  //L[ԕωȂƂitOj
  int chg = 0;		//ʏL[
  int media = 0;	//fBAL[

  // key matrix scan
  for (int row = 0; row < ROW_NUM; row++)
  {
    // swFL[XLJn(LOWo)
    digitalWrite(rowPins[row], LOW);

    for (int col = 0; col < COL_NUM; col++)
    {
      // wFL[ԓǂݏo(:LOWj
      cur_key_sts[row][col] = digitalRead(colPins[col]);

      // ȌԂƕωH
      if (cur_key_sts[row][col] != old_key_sts[row][col])
      {
        //uL[ԕωvƂ
        chg = 1;
      	
      	//L[R[h}bv擾
      	unsigned int key_code = keyMap[row][col];
      	
        // L[ĂH
        if (cur_key_sts[row][col] == LOW)
        {
          //fBAL[wH
          if(key_code & C_MEDIA)
          {
            //fBAL[ƂB
            media = 1;
          }
          else
          {
            //SHIFT{wH
            if(key_code & C_SHIFT)
            {
              // SHIFTL[
              BootKeyboard.add(KeyboardKeycode(KC_SHIFT));
            }
            // L[R[hǉij
            BootKeyboard.add(KeyboardKeycode(key_code&0xff));
          }
        }
        else
        {
          //fBAL[wH
          if(key_code & C_MEDIA)
          {
            //fBAL[[X͉Ȃ
            ;
          }
          else
          {
            // L[R[h폜i[Xj
            BootKeyboard.remove(KeyboardKeycode(key_code&0xff));
            //SHIFT{wH
            if(key_code & C_SHIFT)
            {
              // SHIFTL[[X
              BootKeyboard.remove(KeyboardKeycode(KC_SHIFT));
            }
          }
        }
        //݂̃L[ԂȌԂɃRs[
        old_key_sts[row][col] = cur_key_sts[row][col];
      }
	}
    // swFL[XLI(HIGHɖ߂)
    digitalWrite(rowPins[row], HIGH);
  }
  //fBAL[H
  if( media==1 )
  {
    //dL[𑗐M
    Consumer.write(ConsumerKeycode(CONSUMER_CALCULATOR));
  }
  //L[ԕωH
  if ( chg == 1 )
  {
    //zXgɕωL[R[h𑗐M
    BootKeyboard.send();
  }

  //zXgLEDԂ擾
  int cur_led_sts = BootKeyboard.getLeds();
  
  //zXgNumLockԂON
  if( cur_led_sts & LED_NUM_LOCK )
  {
    //LED_(key_modeɏ]RGBw肷)
    pixels.setPixelColor(0, pixels.Color(R[mode],G[mode],B[mode]));
  }
  else
  {
    //LED()
    pixels.setPixelColor(0, pixels.Color(0,0,0));
  }
  //LEDo
  pixels.show();
}
